//+------------------------------------------------------------------+
//|                                                   adxcrossEA.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict



extern string S1 = " --- EA Settings --- ";

///////put indicator settings here...../////

extern string TimeFrame       = "Current time frame";
extern int    AdxPeriod       = 14;
extern bool TradeAtSignal=true;
bool TradeAsLongAs=false;
/////////////////////////////////////////////


extern   int        Magic = 1010;
extern   string     TradeComment = "ADX EA";

extern string S2="---------------- Money Management";

extern double Lotsize=1;//|-----------------------lots size
extern bool RiskMM=true;//|---------------------risk management
extern double RiskPercent=4;//|------------------risk percentage
extern int TakeProfit = 1000;
extern int StopLoss = 200;
extern int MaxOrders=100;//|---------------------maximum orders allowed
extern bool Comments=true;//|--------------------allow comments on chart
extern int Slippage = 2 ;

extern string S5="---------------- Time Filter";

extern bool TradeOnSunday=false;//|---------------time filter on sunday
extern bool MondayToThursdayTimeFilter=true;//|-time filter the week
extern int MondayToThursdayStartHour=11;//|-------start hour time filter the week
extern int MondayToThursdayEndHour=19;//|--------end hour time filter the week
extern bool FridayTimeFilter=true;//|-----------time filter on friday
extern int FridayStartHour=11;//|-----------------start hour time filter on friday
extern int FridayEndHour=19;//|------------------end hour time filter on friday


extern string S6="---------------- Trailing Setttings";

extern int  TS = 1; // Stoploss follows behind current price by X pips
extern bool OnlyTrailProfits = true; // Trailing Stop will only trail when order is profitable
extern bool EnableTS = true;

extern string S16="---------------- Extras";

extern bool Hedge=false;//|----------------------enter an opposite trade
extern int HedgeSL=0;//|-------------------------stop loss
extern int HedgeTP=0;//|-------------------------take profit

extern string S17="---------------- Hide SL and TP";
extern bool HideSL=false;//|---------------------hide stop loss
extern bool HideTP=false;//|---------------------hide take profit



datetime PreviousBarTime1;
datetime PreviousBarTime2;

double maxEquity,minEquity,Balance=0.0;
double LotsFactor=1;
double InitialLotsFactor=1;
double TPP,OPP;
int Expire=0;


int start()


{

//|---------risk management

   if(RiskMM)CalculateMM();

//|---------trailing stop

    trailingStopManager(TS,OnlyTrailProfits,EnableTS);

//|---------time filter

   if((TradeOnSunday==false&&DayOfWeek()==0)||(MondayToThursdayTimeFilter&&DayOfWeek()>=1&&DayOfWeek()<=4&&!(Hour()>=MondayToThursdayStartHour&&Hour()<MondayToThursdayEndHour))||(FridayTimeFilter&&DayOfWeek()==5&&!(Hour()>=FridayStartHour&&Hour()<FridayEndHour)))
   {
      CloseBuyOrders(Magic);
      CloseSellOrders(Magic);
      return(0);
   }


//|---------signal conditions

   int limit=1;
   for(int i=1;i<=limit;i++)
   {
   

   //|---------last price
   
      double LastBuyOpenPrice=0;
      double LastSellOpenPrice=0;
      int BuyOpenPosition=0;
      int SellOpenPosition=0;
      int TotalOpenPosition=0;
      int cnt=0;

      for(cnt=0;cnt<OrdersTotal();cnt++) 
      {
         OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic&&OrderCloseTime()==0) 
         {
            TotalOpenPosition++;
            if(OrderType()==OP_BUY) 
            {
               BuyOpenPosition++;
               LastBuyOpenPrice=OrderOpenPrice();
            }
            if(OrderType()==OP_SELL) 
            {
               SellOpenPosition++;
               LastSellOpenPrice=OrderOpenPrice();
            }
         }
      }

   //|---------main signal....buy and sell conditions
 
      double adx3=iCustom(Symbol(),0,"adxcrossmtf",TimeFrame,AdxPeriod,2,i+2);
      double adx4=iCustom(Symbol(),0,"adxcrossmtf",TimeFrame,AdxPeriod,2,i+1);
      double adx5=iCustom(Symbol(),0,"adxcrossmtf",TimeFrame,AdxPeriod,2,i);
      
      bool BUY=false;
      bool SELL=false;

      if((TradeAtSignal&&adx5>adx4&&adx4<adx3)||(TradeAtSignal==false&&adx4<adx3))BUY=true;
      if((TradeAtSignal&&adx5<adx4&&adx4>adx3)||(TradeAtSignal==false&&adx4>adx3))SELL=true;
      
      bool SignalBUY=false;
      bool SignalSELL=false;
      
  
      
   }



//|---------open orders
     bool SignalBUY=false;
      bool SignalSELL=false;
   double SL,TP,SLH,TPH,SLP,TPP,OPP,ILots;
   int Ticket,TicketH,TicketP,Expire=0;
   /*if(Expiration>0)Expire=TimeCurrent()+(Expiration*60)-5;*/

   if((CountOrders(OP_BUY,Magic)+CountOrders(OP_SELL,Magic))<MaxOrders)
   {  
      if((SignalBUY&&((TradeAsLongAs==false && NewBarBuy())||(TradeAsLongAs)))/*||(SignalBUY&&CountOrders(OP_BUY,Magic)<1)*/)
      {
         if(HideSL==false&&StopLoss>0){SL=Ask-StopLoss*Point;/*OPP=Bid-StopLoss*Point;SLP=Bid;*/}else {SL=0;/*SLP=0;*/}
         if(HideTP==false&&TakeProfit>0){TP=Ask+TakeProfit*Point;/*TPP=Bid-(TakeProfit*2)*Point;*/}else {TP=0;/*TPP=0;*/}
         if(HideSL==false&&HedgeSL>0)SLH=Bid+HedgeSL*Point;else SLH=0;
         if(HideTP==false&&HedgeTP>0)TPH=Bid-HedgeTP*Point;else TPH=0;
     
    
         
         Ticket=OrderSend(Symbol(),OP_BUY,ILots,Ask,Slippage,SL,TP,TradeComment,Magic,0,Blue);
         if(Hedge)TicketH=OrderSend(Symbol(),OP_SELL,ILots,Bid,Slippage,SLH,TPH,TradeComment,Magic,0,Red);
       
      }
      if((SignalSELL&&((TradeAsLongAs==false && NewBarSell())||(TradeAsLongAs)))/*||(SignalSELL&&CountOrders(OP_SELL,Magic)<1)*/)
      {
         if(HideSL==false&&StopLoss>0){SL=Bid+StopLoss*Point;/*OPP=Ask+StopLoss*Point;SLP=Ask;*/}else {SL=0;/*SLP=0;*/}
         if(HideTP==false&&TakeProfit>0){TP=Bid-TakeProfit*Point;/*TPP=Ask+(TakeProfit*2)*Point;*/}else {TP=0;/*TPP=0;*/}
         if(HideSL==false&&HedgeSL>0)SLH=Ask-HedgeSL*Point;else SLH=0;
         if(HideTP==false&&HedgeTP>0)TPH=Ask+HedgeTP*Point;else TPH=0;
     
        
         
         Ticket=OrderSend(Symbol(),OP_SELL,ILots,Bid,Slippage,SL,TP,TradeComment,Magic,0,Red);
         if(Hedge)TicketH=OrderSend(Symbol(),OP_BUY,ILots,Ask,Slippage,SLH,TPH,TradeComment,Magic,0,Blue);
         /*if(ReverseAtStop&&StopLoss>0)TicketP=OrderSend(Symbol(),OP_BUYSTOP,Lots,OPP,Slippage,SLP,TPP,EAName,Magic,Expire,Red);*/
      }
   }

//|---------close orders
    bool BUY=false;
    bool SELL=false;
   if(Hedge==false&&SELL)
   {
    
   }
   if(Hedge==false&&BUY)
   {
      
   }
   
   //|---------hidden sl-tp
   
   if(Hedge==false&&HideSL&&StopLoss>0)
   {
      CloseBuyOrdersHiddenSL(Magic);CloseSellOrdersHiddenSL(Magic);
   }
   if(Hedge==false&&HideTP&&TakeProfit>0)
   {
      CloseBuyOrdersHiddenTP(Magic);CloseSellOrdersHiddenTP(Magic);
   }

//|---------not enough money warning

   int err=0;
   if(Ticket<0)
   {
      if(GetLastError()==134)
      {
         err=1;
         Print("Not enough money!");
      }
      return (-1);
   }
   

   if(Comments)
   {
      Comment("\nCopyright  2015, Forex-TSD",
              "\n\nL o t s                   =  " + DoubleToStr(Lotsize,2),
              "\nB a l a n c e         =  " + DoubleToStr(AccountBalance(),2),
              "\nE q u i t y            =  " + DoubleToStr(AccountEquity(),2));
   }


   return(0);
}

//|---------close buy orders

int CloseBuyOrders(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenTP(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid>(OrderOpenPrice()+TakeProfit*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenSL(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid<(OrderOpenPrice()-StopLoss*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

//|---------close sell orders

int CloseSellOrders(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}


int CloseSellOrdersHiddenTP(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask<(OrderOpenPrice()-TakeProfit*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

int CloseSellOrdersHiddenSL(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask>(OrderOpenPrice()+StopLoss*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

//|---------count orders

int CountOrders(int Type,int Magic)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
      {
         if((OrderType()==Type&&(OrderMagicNumber()==Magic)||Magic==0))_CountOrd++;
      }
   }
   return(_CountOrd);
}




//|---------allow one action per bar

bool NewBarBuy()
{
   if(PreviousBarTime1<Time[0])
   {
      PreviousBarTime1=Time[0];
      return(true);
   }
   return(false);
}

bool NewBarSell()
{
   if(PreviousBarTime2<Time[0])
   {
      PreviousBarTime2=Time[0];
      return(true);
   }
   return(false);
}

//|---------calculate money management

void CalculateMM()
{
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   Lotsize=AccountFreeMargin()/100000*RiskPercent;
   Lotsize=MathMin(MaxLots,MathMax(MinLots,Lotsize));
   if(MinLots<0.1)Lotsize=NormalizeDouble(Lotsize,2);
   else
   {
     if(MinLots<1)Lotsize=NormalizeDouble(Lotsize,1);
     else Lotsize=NormalizeDouble(Lotsize,0);
   }
   if(Lotsize<MinLots)Lotsize=MinLots;
   if(Lotsize>MaxLots)Lotsize=MaxLots;
 
}



void trailingStopManager(int tsV, bool profits,bool enableTS){
   
   double pointer, bidder, asker;
   
   if (enableTS == true){
   
      for(int cnt=0;cnt<OrdersTotal();cnt++){
   
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if ((tsV>0) && (Symbol() == OrderSymbol()) && (OrderMagicNumber() == Magic)){
      
            bidder  = MarketInfo(OrderSymbol(),MODE_BID);
            asker   = MarketInfo(OrderSymbol(),MODE_ASK);
            pointer = MarketInfo(OrderSymbol(),MODE_POINT);
         
            if (OrderType()==OP_BUY){
               if ((bidder-OrderOpenPrice()>pointer*tsV) || profits==false){
                  if (OrderStopLoss()<bidder-pointer*tsV){
                     OrderModify(OrderTicket(),OrderOpenPrice(),bidder-pointer*tsV,OrderTakeProfit(),0,Green); 
                  }
               }
            }
            else if (OrderType()==OP_SELL){
               if ((OrderOpenPrice()-asker>pointer*tsV) || profits==false){
                  if ((OrderStopLoss()>(asker+pointer*tsV)) || (OrderStopLoss()==0)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),asker+pointer*tsV,OrderTakeProfit(),0,Red); 
                  }
               }
            }
         }//tsV  
      }//for 
      
   }
   
}